栏目分类:
子分类:
返回
名师互学网用户登录
快速导航关闭
当前搜索
当前分类
子分类
实用工具
热门搜索
名师互学网 > IT > 软件开发 > 后端开发 > C/C++/C#

luogu-P1280 尼克的任务【线性动态规划】

C/C++/C# 更新时间: 发布时间: IT归档 最新发布 模块sitemap 名妆网 法律咨询 聚返吧 英语巴士网 伯小乐 网商动力

luogu-P1280 尼克的任务【线性动态规划】

P1280 尼克的任务 link

思路:
我们考虑用线性动规。
设f[i]表示1~i的最大空闲时间,但是我们会发现对于当前选的工作会对后面的产生影响,不满足最优子结构。
那反过来,设f[i]表示i~n的最大空闲时间。
对于当前时间点:

  1. 如果无工作开始,f[i] = f[i + 1] + 1;
  2. 如果有工作开始,那我们们就判断对于当前点我们选择哪一个工作的空闲时间最大,即:f[i] = max(f[i], f[i + a[num].t]); //num表示当前点开始的工作,a[num].t表示该工作的持续时间。

因为我们是从后往前枚举,所以要按照开始时间从大到小排序。

#include 
#include 
#include 
#include 

using namespace std;

const int N = 1e4 + 10;

struct node {int p, t;} a[N];

int n, k, sum[N], f[N], num = 1;

bool cmp(node aa, node bb) {return aa.p > bb.p;}

int main()
{
	scanf("%d%d", &n, &k);
	for(int i = 1; i <= k; i++)
	{
		scanf("%d%d", &a[i].p, &a[i].t);
		sum[a[i].p]++;
	}
	sort(a + 1, a + 1 + k, cmp);
	for(int i = n; i >= 1; i--)
	{
		if(sum[i] == 0) f[i] = f[i + 1] + 1;
		else
		{
			for(int j = 1; j <= sum[i]; j++)
			{
				if(f[i + a[num].t] > f[i]) f[i] = f[i + a[num].t];
				num++;	
			}
		}
	}
	printf("%dn", f[1]);
	return 0;
}
转载请注明:文章转载自 www.mshxw.com
本文地址:https://www.mshxw.com/it/960072.html
我们一直用心在做
关于我们 文章归档 网站地图 联系我们

版权所有 (c)2021-2022 MSHXW.COM

ICP备案号:晋ICP备2021003244-6号